package vhdl

import core._

sealed trait VHDLBuiltin extends Builtin

case class ReorderArray(input: IR) extends VHDLBuiltin {
  override val innerIR: IR = {
    val atv = ArrayTypeVar(NoStreamDataTypeVar(), ArithTypeVar())
    FunctionCall(BuiltinFunction(FunType(atv, atv)), input)
  }
}

case class SplitArray(input: IR, cs: IR, inarrayt: TypeT = ArrayTypeVar(), cst: TypeT = ArithTypeVar()) extends VHDLBuiltin {
  override val innerIR: IR = {
    val atv = ArrayTypeVar()
    val cstv = ArithTypeVar()

    FunctionCall(TypeFunctionCall(BuiltinTypeFunction(TypeFunType(Seq(atv, cstv), FunType(Seq(atv, cstv), ArrayType(ArrayType(atv.et, cstv), atv.len.ae / cstv)))), Seq(inarrayt, cst)), Seq(input, cs))
  }
}

//object splitStream extends VhdlFunDecl(   {
//  val cs = ArithTypeVar() // chunk size
//  val n = ArithTypeVar()  // number of elements in the input
//  val et = VHDLDataTypeVar()  // element type
//
//  FunType(Seq(StreamType(et,n)), StreamType(StreamType(et,cs),n/cs))
//})
//
//object joinArray extends VhdlFunDecl(   {
//  val m = ArithTypeVar()
//  val n = ArithTypeVar()
//  val et = NoStreamDataTypeVar()
//
//  FunType(Seq(ArrayType(ArrayType(et,m),n)), ArrayType(et,m*n))
//})
//
//object joinStream extends VhdlFunDecl(   {
//  val m = ArithTypeVar()
//  val n = ArithTypeVar()
//  val et = VHDLDataTypeVar()
//
//  FunType(Seq(StreamType(StreamType(et,m),n)), StreamType(et,m*n))
//})
//
//object mapStream extends VhdlFunDecl(   {
//  val tvT = VHDLDataTypeVar()
//  val tvU = VHDLDataTypeVar()
//  val fTU = FunType(tvT, tvU)
//
//  val tvLen = ArithTypeVar()
//  FunType(Seq(fTU, StreamType(tvT,tvLen)), StreamType(tvU,tvLen))
//})
//
//// not sure if needed since we could: toStream => mapStream => toArray
//object mapArray extends VhdlFunDecl(   {
//  val tvT = NoStreamDataTypeVar()
//  val tvU = NoStreamDataTypeVar()
//  val fTU = FunType(tvT,tvU)
//
//  val tvLen = ArithTypeVar()
//  FunType(Seq(fTU, ArrayType(tvT,tvLen)), ArrayType(tvU,tvLen))
//})
//
//object toArray extends VhdlFunDecl(   {
//  val t = NoStreamDataTypeVar()
//  val n = ArithTypeVar()
//  FunType(Seq(StreamType(t,n)), ArrayType(t,n))
//})
//
//object toStream extends VhdlFunDecl(   {
//  val t = NoStreamDataTypeVar()
//  val n = ArithTypeVar()
//  FunType(Seq(ArrayType(t,n)), StreamType(t,n))
//})
