package core

import algo._
import org.junit.Test
import vhdl.{FloatType, IntType}

class SubTypingTest {

  @Test
  def test(): Unit = {
    val dtv = DataTypeVar()
    val arit1 = ArithType(3)
    val arit2 = ArithType(4)
    val ft1 = FunType(dtv, dtv)
    val ft2 = FunType(dtv, dtv)
    val ft3 = FunType(FloatType(10), dtv)
    val at1 = ArrayType(FloatType(32), ArithType(3))
    val at2 = ArrayType(AbstractScalarTypeVar(), ArithType(3))
    val at3 = ArrayType(IntType(32), ArithType(3))
    val at4 = ArrayType(AbstractScalarTypeVar(), ArithType(4))
    val anyType = new AnyType

    assert(dtv.getCommonSuperKind(ft1) == AnyTypeKind)
    assert(anyType.getCommonSuperKind(dtv) == AnyTypeKind)
    assert(ft1.getCommonSuperKind(ft2) == FunTypeKind)
    assert(at1.getCommonSuperKind(at2) == ArrayTypeKind)

    assert(arit1.isSubTypeOf(arit2) == Option(false))

    assert(ft1.isSubTypeOf(ft2) == Option(true))
    assert(ft2.isSubTypeOf(ft1) == Option(true))
    assert(ft1.isSubTypeOf(dtv) == Option(false))

    assert(ft1.isSubTypeOf(ft3).isEmpty)
    assert(ft3.isSubTypeOf(ft1).isEmpty)

    assert(at1.isSubTypeOf(at2).isEmpty)
    assert(at1.isSubTypeOf(at3) == Option(false))

    assert(at1.isSubTypeOf(at4) == Option(false))
  }

}
